'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var fs = require('fs');
var path = require('path');
var debug = require('debug')('generator-ats-node-webapp:writer');
var DOT_FILES = {
  'editorconfig': true,
  'eslintrc': true,
  'gitignore': true,
  'gitattributes': true,
  'nodemonignore': true
};

/**
 * Recursively processes content in a directory.
 * Files ending with '.tpl' will be processed as templates using 'this.props' as the template context.
 *
 * @param dir The absolute directory to process
 * @param templatePath The relative template path
 * @param context The yeoman context
 */

var PathScanner = (function () {
  function PathScanner() {
    _classCallCheck(this, PathScanner);

    this.process = this.process.bind(this);
  }

  _createClass(PathScanner, [{
    key: 'process',
    value: function process(dir, templateDir, context) {
      var _this = this;

      fs.readdirSync(dir).forEach(function (file) {
        var filePath = path.join(dir, file);
        var templatePath = path.join(templateDir, file);
        var isDirectory = fs.statSync(filePath).isDirectory();

        if (isDirectory) {
          debug('processing dir', filePath);
          _this.process(filePath, templatePath, context);
        } else {
          debug('processing file', filePath);
          var isTemplate = file.indexOf('.tpl') > -1;
          var targetFilename = path.join(templateDir, (DOT_FILES[file] ? '.' : '') + file).replace('.tpl', '');
          var method = isTemplate ? 'copyTpl' : 'copy';

          try {
            context.fs[method](context.templatePath(templatePath), context.destinationPath(targetFilename), context.props);
          } catch (err) {
            debug('Error processing template using ' + method + ':', templatePath);
            throw err;
          }
        }
      });
    }
  }]);

  return PathScanner;
})();

module.exports = PathScanner;